%This Example for using users m-function problem_Cvar_cycle.m was created automatically by PSG Toolbox.

%Function description:

%for {alpha; par_poe; par_bpoe}={900; 4413.2; 4928.942},{950; 4730.8; 5324.89},{990; 5513.708; 5714.379},{995; 5611.493; 5859.674}
%
%problem_cvar_alpha, minimize
%linearize=1 
%cvar_risk_g(0.alpha, matrix_scenarios_large)  
%constraint: = 0
%linearmulti(matrix_linearmulty_large)
%box: types=1, mip=1 
%solver: cargrb, timelimit=3600
%
%value:
%bpoe_g(par_bpoe, matrix_scenarios_large)
%var_risk_g(0.alpha, matrix_scenarios_large)
%pr_pen_g(par_poe, matrix_scenarios_large)
%
%end for
%
%Input variables:
%
%Inputs                                PSG Type    PSG Object                  Location in Problem Statement                     Class
%matrix_scenarios_large_data           data        matrix_scenarios_large      cvar_risk_g(0.alpha, matrix_scenarios_large)      double
%                                                                              bpoe_g(par_bpoe, matrix_scenarios_large)
%                                                                              var_risk_g(0.alpha, matrix_scenarios_large)
%                                                                              pr_pen_g(par_poe, matrix_scenarios_large)
%matrix_scenarios_large_vars           vars        matrix_scenarios_large      cvar_risk_g(0.alpha, matrix_scenarios_large)      cell
%                                                                              bpoe_g(par_bpoe, matrix_scenarios_large)
%                                                                              var_risk_g(0.alpha, matrix_scenarios_large)
%                                                                              pr_pen_g(par_poe, matrix_scenarios_large)
%matrix_linearmulty_large_benchmark    bench       matrix_linearmulty_large    linearmulti(matrix_linearmulty_large)             double
%matrix_linearmulty_large_data         data        matrix_linearmulty_large    linearmulti(matrix_linearmulty_large)             double
%matrix_linearmulty_large_vars         vars        matrix_linearmulty_large    linearmulti(matrix_linearmulty_large)             cell
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


%Load data from mat-file:
load('D:\American Optimal Decisions\PSG\MATLAB\CS_SSP\data_problem_Cvar_cycle\problem_Cvar_cycle_data.mat')

%Save variables from mat-file to Workspace:
tbpsg_export_to_workspace(toolboxstruc_arr)

%Run users m-function problem_Cvar_cycle:

[solution_str,outargstruc_arr] = problem_Cvar_cycle(matrix_scenarios_large_data,matrix_scenarios_large_vars,matrix_linearmulty_large_benchmark,matrix_linearmulty_large_data,matrix_linearmulty_large_vars);

%Extract Objective:
val_obj = tbpsg_objective(solution_str, outargstruc_arr);

disp(' ');
disp('Objective = ');
disp(val_obj);

%Extract optimal solution:
point_data = tbpsg_optimal_point_data(solution_str, outargstruc_arr);

disp(' ');
disp('Optimal point = ');
disp(point_data);

%Extract structure containing PSG solution reports:
output_structure = tbpsg_solution_struct(solution_str, outargstruc_arr);

disp(' ');
disp('Structure with PSG solution = ');
disp(output_structure);

%Uncomment the following lines to extract solutions details:

%output = tbpsg_isoptimal(solution_str, outargstruc_arr);

%output = tbpsg_function_data(solution_str, outargstruc_arr);

%output = tbpsg_function_names(solution_str, outargstruc_arr);

%output = tbpsg_time(solution_str, outargstruc_arr);

%output = tbpsg_optimal_point_vars(solution_str, outargstruc_arr);

%output = tbpsg_constraints_vars(solution_str, outargstruc_arr);

%output = tbpsg_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_constraint_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_vars(solution_str, outargstruc_arr);

%output = tbpsg_vector_data(solution_str, outargstruc_arr);

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2018.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 
